
* example 1;
data names;
input last_name : $25. first_name : $15. @@;
* old way;
full_name_old_way = trim(last_name) || ', ' || first_name;
* new way;
full_name_new_way = catx(', ',last_name,first_name);
datalines;
Zdeb Mike Washington George Squirrel Rocket(J)
;
run;

title 'example 1';
proc print data=names;
run;

* example2;
data answers;
input id : $5. (a1-a10) (: $1.);
datalines;
A1234 Y Y Y Y Y Y Y Y N N
A2345 N N N N N N N N N N
A3456 N N N N N N N N N Y
A4567 N N N N Y N N N N N
A5678 Y N N Y N N Y N N Y
;
run;

title 'example 2/answers';
proc print data=answers;
run;

* array and a loop;
data yes;
set answers;
array a(10);
do j=1 to 10 until (a(j) eq 'Y');
end;
if j lt 11;
drop j;
run;

title 'example 2/loop';
proc print data=yes;
run;

* cat and find;
data yes;
set answers;
if find(cat(of a1-a10),'Y');
run;

title 'example 2/cat';
proc print data=yes;
run;


* example 3;
* array and a loop;
data yes;
set answers;
array a(10);
do j=1 to 10 until (found_y eq 2);
found_y = sum(found_y,(a(j) eq 'Y'));
end;
if found_y eq 2;
drop j found_y;
run;

title 'example 3/loop';
proc print data=yes;
run;

* cat and countc;
data yes;
set answers;
if countc(cat(of a1-a10),'Y') ge 2;
run;

title 'example 3/cat';
proc print data=yes;
run;


* array and a loop;
data yes;
set answers;
array a(10);
do _n_=1 to 10;
found_y = sum(found_y,(a(_n_) eq 'Y'));
end;
run;

title 'example 4/loop';
proc print data=yes;
run;

* cat and countc;
data yes;
set answers;
found_y = countc(cat(of a:),'Y');
run;

title 'example 4/cat';
proc print data=yes;
run;

* example5;
data answers;
input id : $5. a1-a10;
datalines;
A1234 5 5 3 3 2 1 1 1 1 1
A2345 0 0 0 0 0 0 0 5 5 5
A3456 1 1 2 2 4 0 0 0 0 0
A4567 5 5 5 5 5 5 5 5 5 5
A5678 1 0 1 0 1 0 5 5 5 3
;
run;

title 'example 5/answers';
proc print data=answers;
run;

* array and a loop;
data five;
set answers;
array a(10);
do j=1 to 10 until (a(j) eq 5);
end;
if j jt 11;
drop j
run;

title 'example 5/loop';
proc print data=five;
run;

* cat and find;
data five;
set answers;
if find(cat(of a:),'5');
run;

title 'example 5/cat';
proc print data=five;
run;


* example 6;
data cat_numeric;
set answers;
new_way = cat(of a:);
old_way = a1 || a2 || a3 || a4 || a5 || a6 || a7 || a8 || a9 || a10;
run;

title 'example 6/cat_numeric';
proc print data=cat_numeric;
var new_way old_way;
run;

proc contents data=cat_numeric;
ods select variables;
run;


* example 7;
data diag3;
infile datalines truncover;
input (dx1-dx5) (: $3.);
datalines;
025 022
682 401 244 493
592 401 493
428 493 780 V43 250
250
414 V45 401 250
;
run;

title 'example 7/diag3';
proc print data=diag3;
run;

data dia_incorrect;
set diag3;
if find(cat(of dx1-dx5),'250') ne 0;
run;

title 'example 7/incorrect';
proc print data=dia_incorrect;
run;

data dia_correct;
set diag3;
if find(catx('*',of dx1-dx5),'250') ne 0;
run;

title 'example 7/correct';
proc print data=dia_correct;
run;


* example 8;
data dia_ast;
set diag3;
dia = (find(catx('*',of dx1-dx5),'250') ne 0);
ast = (find(catx('*',of dx1-dx5),'493') ne 0);
run;

title 'example 8/dia_ast';
proc print data=dia_ast;
run;


* example 9;
data diag5;
infile datalines truncover;
input (dx1-dx5) (: $5.);
datalines;
25001 V180
5680 78039 6250 49390 53081
4270 4111 4019 36250
486 7990 25082 41400
78659 25000 49320
49392 4660 2449
34839 2765 40493 4280
;
run;

title 'example 9/diag5';
proc print data=diag5;
run;

data dia_ast;
set diag5;
array dx(5);
dia = 0;
ast = 0;
do j=1 to 5;
if dx(j) eq : '250' then dia = 1;
if dx(j) eq : '493' then ast = 1;
end;
drop j;
run;

title 'example 9/loop';
proc print data=dia_ast;
run;

data dia_ast_incorrect;
set diag5;
dia = (find(catx('*',of dx1-dx5),'*250') gt 0);
ast = (find(catx('*',of dx1-dx5),'*493') gt 0);
run;

title 'example 9/incorrect';
proc print data=dia_ast_incorrect;
run;

data dia_ast_correct;
set diag5;
dia = (find(catx('*','*',of dx1-dx5),'*250') gt 0);
ast = (find(catx('*','*',of dx1-dx5),'*493') gt 0);
run;

title 'example 9/correct';
proc print data=dia_ast_correct;
run;
